| Earth Observation Mission CFI Software Lib Software User Manual |

Public Member Functions

# EECFI::TimeCorrelation Class Reference

Class that stores the time correlations. More...

Inheritance diagram for EECFI::TimeCorrelation:

List of all members.

## Public Member Functions
| TimeCorrelation (double time_corr[4]) throw (CfiError)
| Class constructor: using time correlations.
| TimeCorrelation (long timeModel, vector< string > timeFiles, TimeInterval time, TimeInterval &valTime) throw (CfiError)
| Class constructor: using files and times.
| TimeCorrelation (long timeModel, vector< string > timeFiles, long timeRef, OrbitInterval orbits, TimeInterval &valTime) throw (CfiError)
| Class constructor: using files and orbits.
| TimeCorrelation (long timeModel, vector< string > timeFiles, long timeRef, TimeInterval &valTime) throw (CfiError)
| Class constructor: using files and default initialisation interval.
| TimeCorrelation (long timeModel, vector< OsfFile > fileData, TimeInterval time, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from OSF files and times.
| TimeCorrelation (long timeModel, vector< OsfFile > fileData, long timeRef, OrbitInterval orbits, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from OSF files and orbits.
| TimeCorrelation (long timeModel, vector< OsfFile > fileData, long timeRef, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from OSF files and default initialisation interval.
| TimeCorrelation (long timeModel, vector< OrbitFile > fileData, TimeInterval time, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from Orbit files and times.
| TimeCorrelation (long timeModel, vector< OrbitFile > fileData, long timeRef, OrbitInterval orbits, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from Orbit files and orbits.
| TimeCorrelation (long timeModel, vector< OrbitFile > fileData, long timeRef, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from Orbit files and default initialisation interval.
| TimeCorrelation (long timeModel, vector< DorisFile > fileData, TimeInterval time, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from DORIS Navigator files and times.
| TimeCorrelation (long timeModel, vector< DorisFile > fileData, long timeRef, OrbitInterval orbits, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from DORIS Navigator files and orbits.
| TimeCorrelation (long timeModel, vector< DorisFile > fileData, long timeRef, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from DORIS Navigator files and default initialisation interval.
| TimeCorrelation (long timeModel, vector< IersBulletinFile > fileData, TimeInterval time, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from IERS bulletin files and times.
| TimeCorrelation (long timeModel, vector< IersBulletinFile > fileData, long timeRef, OrbitInterval orbits, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from IERS bulletin files and orbits.
| TimeCorrelation (long timeModel, vector< IersBulletinFile > fileData, long timeRef, TimeInterval &valTime) throw (CfiError)
| Class constructor: using data read from IERS bulletin files and default initialisation interval.
| TimeCorrelation (const TimeCorrelationData &timeData, long timeRef, TimeInterval &valTime) throw (CfiError)
| Class constructor: with user define Time correlation data.
| TimeCorrelation ()
| Empty Class constructor: do not initialise time correlations.
| ~TimeCorrelation () throw (CfiError)
| Class destructor.
TimeCorrelationData | getData ()
| Get data.
void | getLeapSecondInfo (long asciiFormat, long &leapFlag, string &UtcTimeBeforeLeap, string &UtcTimeAfterLeap) throw (CfiError)
| Get leap second info.
void | setData (TimeCorrelationData timeCorr)
| Set data (the TimeCorrelation object has to be initialized).

## Detailed Description

Class that stores the time correlations.

## Constructor & Destructor Documentation

EECFI::TimeCorrelation::TimeCorrelation | ( | double | time_corr[4] | ) | throw (CfiError)

Class constructor: using time correlations.

Parameters:

  | time_corr | Time correlations array: [0] = TAI time (Decimal days - Processing format). Allowed range=[-18262.0, 36524.0] [1] = UTC time (Decimal days - Processing format). Allowed range=[-18262.0, 36524.0] [2] = UT1 time (Decimal days - Processing format). Allowed range=[-18262.0, 36524.0] [3] = GPS time (Decimal days - Processing format). Allowed range=[-18262.0, 36524.0].

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< string > | timeFiles,
|  | TimeInterval | time,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using files and times.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: complete except XLCFI_TIMEMOD_USER. Note: when the input file is an IERS Bulleting B file and the time mode is XLCFI_TIMEMOD_AUTO, then the time model is set automatically to XLCFI_TIMEMOD_IERS_B_RESTITUTED. Time interval initialisation is not allowed for Orbit Scenario Files.
  | timeFiles | Array of files.
  | time | Requested initialisation time window.
  | valTime | [OUTPUT] Time validity interval.

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< string > | timeFiles,
|  | long | timeRef,
|  | OrbitInterval | orbits,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using files and orbits.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: complete except XLCFI_TIMEMOD_USER. Initialisation with orbit interval is not allowed for IERS Bulletins, DORIS Navigator files nor Orbit Scenario Files files.
  | timeFiles | Array of files.
  | timeRef | Time reference for the validity interval.
  | orbits | Requested initialisation orbit window.
  | valTime | [OUTPUT] Time validity interval.

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< string > | timeFiles,
|  | long | timeRef,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using files and default initialisation interval.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: complete except XLCFI_TIMEMOD_USER. Note: when the input file is an IERS Bulleting B file and the time mode is XLCFI_TIMEMOD_AUTO, then the time model is set automatically to XLCFI_TIMEMOD_IERS_B_RESTITUTED.
  | timeFiles | Array of files.
  | timeRef | Time reference for the validity interval.
  | valTime | [OUTPUT] Time validity interval.

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< OsfFile > | fileData,
|  | TimeInterval | timeInterval,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from OSF files and times.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_OSF XLCFI_TIMEMOD_AUTO
  | fileData | Array of files.
  | timeInterval | Requested initialisation time window.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< OsfFile > | fileData,
|  | long | timeRef,
|  | OrbitInterval | orbitInterval,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from OSF files and orbits.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_OSF XLCFI_TIMEMOD_AUTO
  | fileData | Array of files.
  | timeRef | Time reference for the validity interval.
  | orbits | Requested initialisation orbit window.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< OsfFile > | fileData,
|  | long | timeRef,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from OSF files and default initialisation interval.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_OSF XLCFI_TIMEMOD_AUTO
  | fileData | Array of files.
  | timeRef | Time reference for the validity interval.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< OrbitFile > | fileData,
|  | TimeInterval | timeInterval,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from Orbit files and times.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_FOS_PREDICTED. XLCFI_TIMEMOD_FOS_RESTITUTED. XLCFI_TIMEMOD_DORIS_PRELIMINARY. XLCFI_TIMEMOD_DORIS_PRECISE. XLCFI_TIMEMOD_AUTO.
  | fileData | Array of files.
  | timeInterval | Requested initialisation time window.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< OrbitFile > | fileData,
|  | long | timeRef,
|  | OrbitInterval | orbitInterval,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from Orbit files and orbits.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_FOS_PREDICTED. XLCFI_TIMEMOD_FOS_RESTITUTED. XLCFI_TIMEMOD_DORIS_PRELIMINARY. XLCFI_TIMEMOD_DORIS_PRECISE. XLCFI_TIMEMOD_AUTO.
  | fileData | Array of files.
  | timeRef | Time reference for the validity interval.
  | orbits | Requested initialisation orbit window.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< OrbitFile > | fileData,
|  | long | timeRef,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from Orbit files and default initialisation interval.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_FOS_PREDICTED. XLCFI_TIMEMOD_FOS_RESTITUTED. XLCFI_TIMEMOD_DORIS_PRELIMINARY. XLCFI_TIMEMOD_DORIS_PRECISE. XLCFI_TIMEMOD_AUTO.
  | fileData | Array of files.
  | timeRef | Time reference for the validity interval.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< DorisFile > | fileData,
|  | TimeInterval | timeInterval,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from DORIS Navigator files and times.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_DORIS_NAVIGATOR XLCFI_TIMEMOD_AUTO
  | fileData | Array of files.
  | timeInterval | Requested initialisation time window.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< DorisFile > | fileData,
|  | long | timeRef,
|  | OrbitInterval | orbitInterval,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from DORIS Navigator files and orbits.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_DORIS_NAVIGATOR XLCFI_TIMEMOD_AUTO
  | fileData | Array of files.
  | timeRef | Time reference for the validity interval.
  | orbits | Requested initialisation orbit window.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< DorisFile > | fileData,
|  | long | timeRef,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from DORIS Navigator files and default initialisation interval.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_DORIS_NAVIGATOR XLCFI_TIMEMOD_AUTO
  | fileData | Array of files.
  | timeRef | Time reference for the validity interval.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< IersBulletinFile > | fileData,
|  | TimeInterval | timeInterval,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from IERS bulletin files and times.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_IERS_B_PREDICTED XLCFI_TIMEMOD_IERS_B_RESTITUTED XLCFI_TIMEMOD_IERS_A_ONLY_PREDICTION XLCFI_TIMEMOD_IERS_A_PREDICTION_AND_FORMULA XLCFI_TIMEMOD_IERS_B_AND_A_ONLY_PREDICTION XLCFI_TIMEMOD_AUTO Note: when the input file is an IERS Bulleting B file and the time mode is XLCFI_TIMEMOD_AUTO, then the time model is set automatically to XLCFI_TIMEMOD_IERS_B_RESTITUTED.
  | fileData | Array of files.
  | timeInterval | Requested initialisation time window.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< IersBulletinFile > | fileData,
|  | long | timeRef,
|  | OrbitInterval | orbitInterval,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from IERS bulletin files and orbits.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_IERS_B_PREDICTED XLCFI_TIMEMOD_IERS_B_RESTITUTED XLCFI_TIMEMOD_IERS_A_ONLY_PREDICTION XLCFI_TIMEMOD_IERS_A_PREDICTION_AND_FORMULA XLCFI_TIMEMOD_IERS_B_AND_A_ONLY_PREDICTION XLCFI_TIMEMOD_AUTO Note: when the input file is an IERS Bulleting B file and the time mode is XLCFI_TIMEMOD_AUTO, then the time model is set automatically to XLCFI_TIMEMOD_IERS_B_RESTITUTED.
  | fileData | Array of files.
  | timeRef | Time reference for the validity interval.
  | orbits | Requested initialisation orbit window.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | long | timeModel,
|  | vector< IersBulletinFile > | fileData,
|  | long | timeRef,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: using data read from IERS bulletin files and default initialisation interval.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeModel | Time model (TimeModelEnum). Allowed range: XLCFI_TIMEMOD_IERS_B_PREDICTED XLCFI_TIMEMOD_IERS_B_RESTITUTED XLCFI_TIMEMOD_IERS_A_ONLY_PREDICTION XLCFI_TIMEMOD_IERS_A_PREDICTION_AND_FORMULA XLCFI_TIMEMOD_IERS_B_AND_A_ONLY_PREDICTION XLCFI_TIMEMOD_AUTO Note: when the input file is an IERS Bulleting B file and the time mode is XLCFI_TIMEMOD_AUTO, then the time model is set automatically to XLCFI_TIMEMOD_IERS_B_RESTITUTED.
  | fileData | Array of files.
  | timeRef | Time reference for the validity interval.
  | valTime | [OUTPUT] Time validity interval.

References EECFI::CfiError::addMsg().

EECFI::TimeCorrelation::TimeCorrelation | ( | const TimeCorrelationData & | timeData,
|  | long | timeRef,
|  | TimeInterval & | valTime |
| ) |  |  | throw (CfiError)

Class constructor: with user define Time correlation data.

EECFI::TimeCorrelation::TimeCorrelation | ( |  | ) |

Empty Class constructor: do not initialise time correlations.

EECFI::TimeCorrelation::~TimeCorrelation | ( |  | ) | throw (CfiError)

Class destructor.

## Member Function Documentation

TimeCorrelationData EECFI::TimeCorrelation::getData | ( |  | ) |

Get data.

Returns:
  Time correlation data.

References EECFI::LaunchInertialFrameConfig::enabledFlag, EECFI::LeapSecondInfo::flag, EECFI::TimeCorrelationData::iersBulletinType, EECFI::TimeCorrelationData::iersFormulaFlag, EECFI::TimeCorrelationData::launchInertialFrameConfig, EECFI::TimeCorrelationData::leapSecond, EECFI::LaunchInertialFrameConfig::longitude, EECFI::TimeCorrelationData::polarMotionFormula, EECFI::TimeCorrelationData::polarMotionParams, EECFI::TimeCorrelationData::predictionFirstRecord, EECFI::TimeData::tai_gps, EECFI::TimeData::tai_ut1, EECFI::TimeData::tai_utc, EECFI::TimeData::taiTime, EECFI::TimeCorrelationData::timeCorrelationFormula, EECFI::TimeCorrelationData::timeCorrVector, EECFI::TimeData::ut1Time, EECFI::LaunchInertialFrameConfig::utcTime, EECFI::LeapSecondInfo::utcTime, EECFI::PolarMotionParams::x, and EECFI::PolarMotionParams::y.

void EECFI::TimeCorrelation::getLeapSecondInfo | ( | long | asciiFormat,
|  | long & | leapFlag,
|  | string & | utcTimeBeforeLeap,
|  | string & | utcTimeAfterLeap |
| ) |  |  | throw (CfiError)

Get leap second info.

Note that, if the time correlations where initalised with an Orbit Scenario File, leap seconds could be wrongly calculated.

Parameters:

  | asciiFormat | Ascii format (TimeAsciiEnum).
  | leapFlag | [OUTPUT] Flag for leap second presence within time initialization data (-1 = Negative leap second; 0 = No leap second within initialization data; 1 = Positive leap second).
  | utcTimeBeforeLeap | [OUTPUT] UTC time just before leap second insertion.
  | utcTimeAfterLeap | [OUTPUT] UTC time just after leap second insertion.

void EECFI::TimeCorrelation::setData | ( | TimeCorrelationData | timeCorr | ) |

Set data (the TimeCorrelation object has to be initialized).

Parameters:

  | timeCorr | Time correlation data.

References EECFI::TimeCorrelationFormula::a, EECFI::PolarMotionFormula::Adiv, EECFI::PolarMotionFormula::Aref, EECFI::PolarMotionFormula::ax, EECFI::PolarMotionFormula::ay, EECFI::TimeCorrelationFormula::b, EECFI::TimeCorrelationFormula::bRef, EECFI::PolarMotionFormula::bx, EECFI::PolarMotionFormula::by, EECFI::PolarMotionFormula::Cdiv, EECFI::PolarMotionFormula::Cref, EECFI::PolarMotionFormula::cx, EECFI::PolarMotionFormula::cy, EECFI::PolarMotionFormula::dx, EECFI::PolarMotionFormula::dy, EECFI::LaunchInertialFrameConfig::enabledFlag, EECFI::PolarMotionFormula::ex, EECFI::PolarMotionFormula::ey, EECFI::LeapSecondInfo::flag, EECFI::TimeCorrelationData::iersBulletinType, EECFI::TimeCorrelationData::iersFormulaFlag, EECFI::TimeCorrelationData::launchInertialFrameConfig, EECFI::TimeCorrelationData::leapSecond, EECFI::LaunchInertialFrameConfig::longitude, EECFI::TimeCorrelationData::polarMotionFormula, EECFI::TimeCorrelationData::polarMotionParams, EECFI::TimeCorrelationData::predictionFirstRecord, EECFI::TimeCorrelationData::timeCorrelationFormula, EECFI::TimeCorrelationData::timeCorrVector, EECFI::LaunchInertialFrameConfig::utcTime, and EECFI::LeapSecondInfo::utcTime.